#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,q;
    int l,r;
    int k,maxk;
    cin>>n>>q;
    unsigned int a[n];
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
    }
    for(int i=0;i<q;i++)
    {
        cin>>l>>r;
        k=0;
        maxk=k;
        for(int j=l;j<r;j++)
        {
            int l2=l,r2=l2;
            for(r2=l2;r2<r;r2++)
            {
                if((a[l2]&&a[r2])>(a[l2] ^ a[r2])) k++;
                else {
                    if(k>maxk)maxk=k;
                    k=0;
                    r2=l2;
                    l2+=1;

                }

            }
           // cout<<maxk<<endl;
        }
        cout<<maxk<<endl;
    }
    return 0;
}